/*
 * sfas.8.c
 * Copyright (C) 2009-2012, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <sfas-names.h>
#include <sfas-types.h>

#define back(miss)			((const char *) (miss))

#define sfnote(sfnote)			((struct sfnote_type *) (sfnote))

static int back_node(const struct fpnode_type *, unsigned, byte **);

static int
back_node(const struct fpnode_type *fpnode_data, unsigned lead, byte **past)
{
    int delete;
    unsigned bits;

    bits = fpnode_data->bits;
    if (Extant(bits)) {
	byte *base;
	unsigned copy, size, trip;

	copy = Length(bits);
	if (sizeof(byte *) < copy) {
	    base = fpnode_data->base;
	    if (copy < Record) {
	    } else {
		copy += strlen(back(base) + Record);
	    }
	} else {
	    base = (void *) &fpnode_data->base;
	}

	size = Spread(bits);

	if (size ^ 1) {
	    fpnode_data = fpnode_data->data;

	    trip = lead + copy;
	    if (Prefix(bits)) {
		trip++;
	    }

	    while (1) {
		delete = back_node(fpnode_data, trip, past);
		if (delete) {
		    break;
		} else {
		    size--;
		    if (size) {
			fpnode_data++;
		    } else {
			break;
		    }
		}
	    }
	} else {
	    delete = 3;
	}

	if (delete) {
	} else {
	    do {
		byte *miss;
		int e;

		miss = *past + lead;
		e = Prefix(bits);
		if (e) {
		    if (e != *miss) {
			delete = 1;
			break;
		    } else {
			miss++;
		    }
		}
		if (copy) {
		    if (memcmp(base, miss, copy)) {
			delete = 2;
		    }
		}
	    } while (0);
	}
    } else {
	byte *base;

	base = fpnode_data->base;
	if (base[lead] != Prefix(bits)) {
	    delete = 4;
	} else {
	    delete = 0;

	    *past = base;
	}
    }

    return delete;
}


int
x1f4_flow_sfnote(void *sfnote)
{
    int delete;
    struct fpnode_type *fpnode_data;

    fpnode_data = sfnote(sfnote)->link_a.fpdeck.fpnode_data;
    if (fpnode_data) {
	byte *none;

	delete = back_node(fpnode_data, 0, &none);
    } else {
	delete = 0;
    }

    return delete;
}
